apiVersion: apiregistration.k8s.io/v1
kind: APIService
metadata:
  name: v1alpha1.acme.nirvati.me
  annotations:
    cert-manager.io/inject-ca-from: "nirvati-me/cert-manager-nirvati-me-webhook-tls"
spec:
  group: acme.nirvati.me
  groupPriorityMinimum: 1000
  versionPriority: 15
  service:
    name: main
    namespace: nirvati-me
  version: v1alpha1
---
apiVersion: cert-manager.io/v1
kind: Certificate
metadata:
  name: nirvati-me-ca
  namespace: "nirvati-me"
spec:
  secretName: nirvati-me-ca
  duration: 43800h # 5y
  issuerRef:
    name: nirvati-me-selfsign
  commonName: "ca.nirvati-me.cert-manager"
  isCA: true
---
apiVersion: cert-manager.io/v1
kind: Certificate
metadata:
  name: cert-manager-nirvati-me-webhook-tls
  namespace: "nirvati-me"
spec:
  secretName: cert-manager-nirvati-me-webhook-tls
  duration: 8760h # 1y
  issuerRef:
    name: nirvati-me-ca
  dnsNames:
    - main
    - main.nirvati-me
    - main.nirvati-me.svc
    - nirvati-me
    - nirvati-me.nirvati-me
    - nirvati-me.nirvati-me.svc
---
apiVersion: cert-manager.io/v1
kind: Issuer
metadata:
  name: nirvati-me-selfsign
  namespace: "nirvati-me"
spec:
  selfSigned: {}
---
apiVersion: cert-manager.io/v1
kind: Issuer
metadata:
  name: nirvati-me-ca
  namespace: "nirvati-me"
spec:
  ca:
    secretName: nirvati-me-ca
---
apiVersion: rbac.authorization.k8s.io/v1
kind: RoleBinding
metadata:
  name: nirvati-me:webhook-authentication-reader
  namespace: kube-system
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: Role
  name: extension-apiserver-authentication-reader
subjects:
  - apiGroup: ""
    kind: ServiceAccount
    name: main
    namespace: nirvati-me
---
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRoleBinding
metadata:
  name: cert-manager-nirvati-me:domain-solver
  labels:
    app: cert-manager-nirvati-me
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: ClusterRole
  name: cert-manager-nirvati-me:domain-solver
subjects:
  - apiGroup: ""
    kind: ServiceAccount
    name: cert-manager
    namespace: cert-manager
---
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRole
metadata:
  name: cert-manager-nirvati-me:domain-solver
  labels:
    app: cert-manager-nirvati-me
rules:
  - apiGroups:
      - acme.nirvati.me
    resources:
      - '*'
    verbs:
      - 'create'
